/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the SuccessResponse type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SuccessResponse{}

// SuccessResponse struct for SuccessResponse
type SuccessResponse struct {
	Status     *string                `json:"status,omitempty"`
	StatusCode *int32                 `json:"status_code,omitempty"`
	Log        []interface{}          `json:"log,omitempty"`
	Data       []interface{}          `json:"data,omitempty"`
	Key        []interface{}          `json:"key,omitempty"`
	Type       []interface{}          `json:"type,omitempty"`
	RowCount   *int32                 `json:"row_count,omitempty"`
	Duration   *float32               `json:"duration,omitempty"`
	Matrix     map[string]interface{} `json:"matrix,omitempty"`
}

// NewSuccessResponse instantiates a new SuccessResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSuccessResponse() *SuccessResponse {
	this := SuccessResponse{}
	return &this
}

// NewSuccessResponseWithDefaults instantiates a new SuccessResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSuccessResponseWithDefaults() *SuccessResponse {
	this := SuccessResponse{}
	return &this
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *SuccessResponse) GetStatus() string {
	if o == nil || IsNil(o.Status) {
		var ret string
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SuccessResponse) GetStatusOk() (*string, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *SuccessResponse) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given string and assigns it to the Status field.
func (o *SuccessResponse) SetStatus(v string) {
	o.Status = &v
}

// GetStatusCode returns the StatusCode field value if set, zero value otherwise.
func (o *SuccessResponse) GetStatusCode() int32 {
	if o == nil || IsNil(o.StatusCode) {
		var ret int32
		return ret
	}
	return *o.StatusCode
}

// GetStatusCodeOk returns a tuple with the StatusCode field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SuccessResponse) GetStatusCodeOk() (*int32, bool) {
	if o == nil || IsNil(o.StatusCode) {
		return nil, false
	}
	return o.StatusCode, true
}

// HasStatusCode returns a boolean if a field has been set.
func (o *SuccessResponse) HasStatusCode() bool {
	if o != nil && !IsNil(o.StatusCode) {
		return true
	}

	return false
}

// SetStatusCode gets a reference to the given int32 and assigns it to the StatusCode field.
func (o *SuccessResponse) SetStatusCode(v int32) {
	o.StatusCode = &v
}

// GetLog returns the Log field value if set, zero value otherwise.
func (o *SuccessResponse) GetLog() []interface{} {
	if o == nil || IsNil(o.Log) {
		var ret []interface{}
		return ret
	}
	return o.Log
}

// GetLogOk returns a tuple with the Log field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SuccessResponse) GetLogOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.Log) {
		return nil, false
	}
	return o.Log, true
}

// HasLog returns a boolean if a field has been set.
func (o *SuccessResponse) HasLog() bool {
	if o != nil && !IsNil(o.Log) {
		return true
	}

	return false
}

// SetLog gets a reference to the given []interface{} and assigns it to the Log field.
func (o *SuccessResponse) SetLog(v []interface{}) {
	o.Log = v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *SuccessResponse) GetData() []interface{} {
	if o == nil || IsNil(o.Data) {
		var ret []interface{}
		return ret
	}
	return o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SuccessResponse) GetDataOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *SuccessResponse) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given []interface{} and assigns it to the Data field.
func (o *SuccessResponse) SetData(v []interface{}) {
	o.Data = v
}

// GetKey returns the Key field value if set, zero value otherwise.
func (o *SuccessResponse) GetKey() []interface{} {
	if o == nil || IsNil(o.Key) {
		var ret []interface{}
		return ret
	}
	return o.Key
}

// GetKeyOk returns a tuple with the Key field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SuccessResponse) GetKeyOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.Key) {
		return nil, false
	}
	return o.Key, true
}

// HasKey returns a boolean if a field has been set.
func (o *SuccessResponse) HasKey() bool {
	if o != nil && !IsNil(o.Key) {
		return true
	}

	return false
}

// SetKey gets a reference to the given []interface{} and assigns it to the Key field.
func (o *SuccessResponse) SetKey(v []interface{}) {
	o.Key = v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *SuccessResponse) GetType() []interface{} {
	if o == nil || IsNil(o.Type) {
		var ret []interface{}
		return ret
	}
	return o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SuccessResponse) GetTypeOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *SuccessResponse) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given []interface{} and assigns it to the Type field.
func (o *SuccessResponse) SetType(v []interface{}) {
	o.Type = v
}

// GetRowCount returns the RowCount field value if set, zero value otherwise.
func (o *SuccessResponse) GetRowCount() int32 {
	if o == nil || IsNil(o.RowCount) {
		var ret int32
		return ret
	}
	return *o.RowCount
}

// GetRowCountOk returns a tuple with the RowCount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SuccessResponse) GetRowCountOk() (*int32, bool) {
	if o == nil || IsNil(o.RowCount) {
		return nil, false
	}
	return o.RowCount, true
}

// HasRowCount returns a boolean if a field has been set.
func (o *SuccessResponse) HasRowCount() bool {
	if o != nil && !IsNil(o.RowCount) {
		return true
	}

	return false
}

// SetRowCount gets a reference to the given int32 and assigns it to the RowCount field.
func (o *SuccessResponse) SetRowCount(v int32) {
	o.RowCount = &v
}

// GetDuration returns the Duration field value if set, zero value otherwise.
func (o *SuccessResponse) GetDuration() float32 {
	if o == nil || IsNil(o.Duration) {
		var ret float32
		return ret
	}
	return *o.Duration
}

// GetDurationOk returns a tuple with the Duration field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SuccessResponse) GetDurationOk() (*float32, bool) {
	if o == nil || IsNil(o.Duration) {
		return nil, false
	}
	return o.Duration, true
}

// HasDuration returns a boolean if a field has been set.
func (o *SuccessResponse) HasDuration() bool {
	if o != nil && !IsNil(o.Duration) {
		return true
	}

	return false
}

// SetDuration gets a reference to the given float32 and assigns it to the Duration field.
func (o *SuccessResponse) SetDuration(v float32) {
	o.Duration = &v
}

// GetMatrix returns the Matrix field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *SuccessResponse) GetMatrix() map[string]interface{} {
	if o == nil {
		var ret map[string]interface{}
		return ret
	}
	return o.Matrix
}

// GetMatrixOk returns a tuple with the Matrix field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *SuccessResponse) GetMatrixOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.Matrix) {
		return map[string]interface{}{}, false
	}
	return o.Matrix, true
}

// HasMatrix returns a boolean if a field has been set.
func (o *SuccessResponse) HasMatrix() bool {
	if o != nil && IsNil(o.Matrix) {
		return true
	}

	return false
}

// SetMatrix gets a reference to the given map[string]interface{} and assigns it to the Matrix field.
func (o *SuccessResponse) SetMatrix(v map[string]interface{}) {
	o.Matrix = v
}

func (o SuccessResponse) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SuccessResponse) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	if !IsNil(o.StatusCode) {
		toSerialize["status_code"] = o.StatusCode
	}
	if !IsNil(o.Log) {
		toSerialize["log"] = o.Log
	}
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	if !IsNil(o.Key) {
		toSerialize["key"] = o.Key
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.RowCount) {
		toSerialize["row_count"] = o.RowCount
	}
	if !IsNil(o.Duration) {
		toSerialize["duration"] = o.Duration
	}
	if o.Matrix != nil {
		toSerialize["matrix"] = o.Matrix
	}
	return toSerialize, nil
}

type NullableSuccessResponse struct {
	value *SuccessResponse
	isSet bool
}

func (v NullableSuccessResponse) Get() *SuccessResponse {
	return v.value
}

func (v *NullableSuccessResponse) Set(val *SuccessResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableSuccessResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableSuccessResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSuccessResponse(val *SuccessResponse) *NullableSuccessResponse {
	return &NullableSuccessResponse{value: val, isSet: true}
}

func (v NullableSuccessResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSuccessResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
